﻿//using System;
//using System.IO;
//using System.Collections.Generic;
//using System.Linq;
//using System.Text;
//using System.Drawing;

using System;
using System.IO;
using System.Drawing;
using System.Collections.Generic;
using System.Text;
using CE3IO;
using System.Windows.Forms;
using mbe;


namespace SmdICpad
{
    class SmdICpadCore
    {
        public const int MIN_X_PINCOUNT = 0;
        public const int MAX_X_PINCOUNT = 100;
        public const int DEFAULT_X_PINCOUNT = 12;
        public const int MIN_Y_PINCOUNT = 1;
        public const int MAX_Y_PINCOUNT = 100;
        public const int DEFAULT_Y_PINCOUNT = 12;
        public const double MAX_XY1 = 50.0;
        public const double MIN_XY1 = 1.0;

        public static double max_XY2(double size_1)
        {
            return size_1 - 0.4;
        }

        public static double min_XY2(double size_1)
        {
            double d1 = size_1 - 20.0;
            return (0.5 > d1 ? 0.5 : d1);
        }
        public const double DEFAULT_X1 = 10.2;
        public const double DEFAULT_Y1 = 10.2;
        public const double DEFAULT_X2 = 7.0;
        public const double DEFAULT_Y2 = 7.0;

        public const double MAX_PIN_PITCH = 6.0;
        public const double MIN_PIN_PITCH = 0.3;
        public const double DEFAULT_PIN_PITCH = 0.5;
        public const double MAX_PAD_WIDTH = (double)MbeObjPinSMD.MAX_PAD_SIZE / 10000;
        public const double MIN_PAD_WIDTH = (double)MbeObjPinSMD.MIN_PAD_SIZE / 10000;
        public const double DEFAULT_PAD_WIDTH = 0.25;

        public static void DoCopy(SmdICpadParam param)
        {
            double padLRwidth = (param.x1 - param.x2) / 2;
            double padLRheight = param.padWidth;
            double padTBwidth = param.padWidth;
            double padTBheight = (param.y1 - param.y2) / 2;
            int pincount = (param.xPinCount + param.yPinCount) * 2;
            int pinNumber = (param.pkgtype == SmdICpadParam.packageType.QFP ? 1 : pincount - param.yPinCount / 2 + 1);
            double x;
            double y;

            LinkedList<MbeObj> objList = new LinkedList<MbeObj>();

            x = -(param.x1 + param.x2) / 4;
            y = param.pinPitch * (param.yPinCount - 1) / 2;
            for (int i = 0; i < param.yPinCount; i++) {
                MbeObjPinSMD pad = new MbeObjPinSMD();
                pad.Shape = MbeObjPin.PadShape.Rect;
                pad.Width = (int)Math.Round(padLRwidth * 10000);
                pad.Height = (int)Math.Round(padLRheight * 10000);
                pad.Layer = MbeLayer.LayerValue.CMP;
                pad.PinNum = pinNumber.ToString();
                pad.SetPos(new Point((int)Math.Round(x * 10000), (int)Math.Round(y * 10000)), 0);
                objList.AddLast(pad);

                pinNumber++;
                if (pinNumber > pincount) {
                    pinNumber = 1;
                }
                y -= param.pinPitch;
            }

            y = -(param.y1 + param.y2) / 4;
            x = -param.pinPitch * (param.xPinCount - 1) / 2;
            for (int i = 0; i < param.xPinCount; i++) {
                MbeObjPinSMD pad = new MbeObjPinSMD();
                pad.Shape = MbeObjPin.PadShape.Rect;
                pad.Width = (int)Math.Round(padTBwidth * 10000);
                pad.Height = (int)Math.Round(padTBheight * 10000);
                pad.Layer = MbeLayer.LayerValue.CMP;
                pad.PinNum = pinNumber.ToString();
                pad.SetPos(new Point((int)Math.Round(x * 10000), (int)Math.Round(y * 10000)), 0);
                objList.AddLast(pad);

                pinNumber++;
                x += param.pinPitch;
            }


            x = (param.x1 + param.x2) / 4;
            y = -param.pinPitch * (param.yPinCount - 1) / 2;
            for (int i = 0; i < param.yPinCount; i++) {
                MbeObjPinSMD pad = new MbeObjPinSMD();
                pad.Shape = MbeObjPin.PadShape.Rect;
                pad.Width = (int)Math.Round(padLRwidth * 10000);
                pad.Height = (int)Math.Round(padLRheight * 10000);
                pad.Layer = MbeLayer.LayerValue.CMP;
                pad.PinNum = pinNumber.ToString();
                pad.SetPos(new Point((int)Math.Round(x * 10000), (int)Math.Round(y * 10000)), 0);
                objList.AddLast(pad);

                pinNumber++;
                y += param.pinPitch;
            }

            y = (param.y1 + param.y2) / 4;
            x = param.pinPitch * (param.xPinCount - 1) / 2;
            for (int i = 0; i < param.xPinCount; i++) {
                MbeObjPinSMD pad = new MbeObjPinSMD();
                pad.Shape = MbeObjPin.PadShape.Rect;
                pad.Width = (int)Math.Round(padTBwidth * 10000);
                pad.Height = (int)Math.Round(padTBheight * 10000);
                pad.Layer = MbeLayer.LayerValue.CMP;
                pad.PinNum = pinNumber.ToString();
                pad.SetPos(new Point((int)Math.Round(x * 10000), (int)Math.Round(y * 10000)), 0);
                objList.AddLast(pad);

                pinNumber++;
                x -= param.pinPitch;
            }

            {
                MbeObjPinSMD pad = new MbeObjPinSMD();
                pad.Shape = MbeObjPin.PadShape.Obround;
                pad.Width = 3000;
                pad.Height = 3000;
                pad.Layer = MbeLayer.LayerValue.PLC;
                pad.SetPos(new Point(0, 0), 0);
                objList.AddLast(pad);
            }



            Point ptOrigin = new Point(0,0);
            MbeDocInfo docinfo = new MbeDocInfo();
            //docinfo.SizeWorkArea = tempRc.SizeRect();

            StringBuilder strBuilder = new StringBuilder();
            StringWriter stringWriter = null;
            try {
                stringWriter = new StringWriter(strBuilder);
                WriteCE3 writeMb3 = new WriteCE3(stringWriter);
                WriteMb3(writeMb3, objList, ptOrigin, docinfo);
                stringWriter.Flush();
                string strBuff = strBuilder.ToString();
                //Clipboard.SetDataObject(strBuff);
                Clipboard.SetData(MainForm.mbeClipboardFormat.Name, strBuff);
            }
            catch (Exception) {
                return;
            }
            return;
        }

        private static void rotateXY(double x,double y,double angle,out double xr,out double yr)
        {
            xr = x * Math.Cos(angle) - y * Math.Sin(angle);
            yr = x * Math.Sin(angle) + y * Math.Cos(angle);
        }


        public static void DoCopy2(SmdICpadParam param)
        {
            double padLRwidth = (param.x1 - param.x2) / 2;
            double padLRheight = param.padWidth;
            double padTBwidth = param.padWidth;
            double padTBheight = (param.y1 - param.y2) / 2;
            int pincount = (param.xPinCount + param.yPinCount) * 2;
            int pinNumber = (param.pkgtype == SmdICpadParam.packageType.QFP ? 1 : pincount - param.yPinCount / 2 + 1);
            double x;
            double y;
            double x1, y1, x2, y2;
            double xr,yr,xr1, yr1, xr2, yr2;
            Point pt1, pt2, ptc;

            LinkedList<MbeObj> objList = new LinkedList<MbeObj>();



            int padWidth = (int)Math.Round(param.padWidth * 10000);
            


            x = -(param.x1 + param.x2) / 4;
            y = param.pinPitch * (param.yPinCount - 1) / 2;
            x1 = x - (padLRwidth - param.padWidth) / 2;
            x2 = x + (padLRwidth - param.padWidth) / 2;


            for (int i = 0; i < param.yPinCount; i++) {
                rotateXY(x, y, param.angle, out xr, out yr);
                rotateXY(x1, y, param.angle, out xr1, out yr1);
                rotateXY(x2, y, param.angle, out xr2, out yr2);

                ptc = new Point((int)Math.Round(xr * 10000), (int)Math.Round(yr * 10000));
                pt1 = new Point((int)Math.Round(xr1 * 10000), (int)Math.Round(yr1 * 10000));
                pt2 = new Point((int)Math.Round(xr2 * 10000), (int)Math.Round(yr2 * 10000));



                MbeObjPinSMD pad = new MbeObjPinSMD();
                pad.Shape = MbeObjPin.PadShape.Obround;
                pad.Width = padWidth;
                pad.Height = padWidth;
                pad.Layer = MbeLayer.LayerValue.CMP;
                pad.PinNum = pinNumber.ToString();
                pad.SetPos(ptc, 0);
                objList.AddLast(pad);

                pinNumber++;
                if (pinNumber > pincount) {
                    pinNumber = 1;
                }

                if (padLRwidth > padLRheight) {
                    MbeObjLine line = new MbeObjLine();
                    line.SetPos(pt1, 0);
                    line.SetPos(ptc, 1);
                    line.LineWidth = padWidth;
                    line.Layer = MbeLayer.LayerValue.CMP;
                    objList.AddLast(line);

                    line = new MbeObjLine();
                    line.SetPos(pt2, 0);
                    line.SetPos(ptc, 1);
                    line.LineWidth = padWidth;
                    line.Layer = MbeLayer.LayerValue.CMP;
                    objList.AddLast(line);

                    line = new MbeObjLine();
                    line.SetPos(pt1, 0);
                    line.SetPos(pt2, 1);
                    line.LineWidth = padWidth;
                    line.Layer = MbeLayer.LayerValue.MMC;
                    objList.AddLast(line);

                    line = new MbeObjLine();
                    line.SetPos(pt1, 0);
                    line.SetPos(pt2, 1);
                    line.LineWidth = padWidth + 2000;
                    line.Layer = MbeLayer.LayerValue.STC;
                    objList.AddLast(line);
                }


                y -= param.pinPitch;
            }

            y = -(param.y1 + param.y2) / 4;
            x = -param.pinPitch * (param.xPinCount - 1) / 2;
            y1 = y - (padTBheight - param.padWidth) / 2;
            y2 = y + (padTBheight - param.padWidth) / 2;
            

            for (int i = 0; i < param.xPinCount; i++) {
                rotateXY(x, y, param.angle, out xr, out yr);
                rotateXY(x, y1, param.angle, out xr1, out yr1);
                rotateXY(x, y2, param.angle, out xr2, out yr2);

                ptc = new Point((int)Math.Round(xr * 10000), (int)Math.Round(yr * 10000));
                pt1 = new Point((int)Math.Round(xr1 * 10000), (int)Math.Round(yr1 * 10000));
                pt2 = new Point((int)Math.Round(xr2 * 10000), (int)Math.Round(yr2 * 10000));


                MbeObjPinSMD pad = new MbeObjPinSMD();
                pad.Shape = MbeObjPin.PadShape.Obround;
                pad.Width = padWidth;
                pad.Height = padWidth; 
                pad.Layer = MbeLayer.LayerValue.CMP;
                pad.PinNum = pinNumber.ToString();

                pad.SetPos(ptc, 0);
                objList.AddLast(pad);

                pinNumber++;

                if (padTBheight > padTBwidth) {
                    MbeObjLine line = new MbeObjLine();
                    line.SetPos(pt1, 0);
                    line.SetPos(ptc, 1);
                    line.LineWidth = padWidth;
                    line.Layer = MbeLayer.LayerValue.CMP;
                    objList.AddLast(line);

                    line = new MbeObjLine();
                    line.SetPos(pt2, 0);
                    line.SetPos(ptc, 1);
                    line.LineWidth = padWidth;
                    line.Layer = MbeLayer.LayerValue.CMP;
                    objList.AddLast(line);

                    line = new MbeObjLine();
                    line.SetPos(pt1, 0);
                    line.SetPos(pt2, 1);
                    line.LineWidth = padWidth;
                    line.Layer = MbeLayer.LayerValue.MMC;
                    objList.AddLast(line);

                    line = new MbeObjLine();
                    line.SetPos(pt1, 0);
                    line.SetPos(pt2, 1);
                    line.LineWidth = padWidth + 2000;
                    line.Layer = MbeLayer.LayerValue.STC;
                    objList.AddLast(line);
                }



                x += param.pinPitch;
            }


            x = (param.x1 + param.x2) / 4;
            y = -param.pinPitch * (param.yPinCount - 1) / 2;
            x1 = x - (padLRwidth - param.padWidth) / 2;
            x2 = x + (padLRwidth - param.padWidth) / 2;



            for (int i = 0; i < param.yPinCount; i++) {
                rotateXY(x, y, param.angle, out xr, out yr);
                rotateXY(x1, y, param.angle, out xr1, out yr1);
                rotateXY(x2, y, param.angle, out xr2, out yr2);

                ptc = new Point((int)Math.Round(xr * 10000), (int)Math.Round(yr * 10000));
                pt1 = new Point((int)Math.Round(xr1 * 10000), (int)Math.Round(yr1 * 10000));
                pt2 = new Point((int)Math.Round(xr2 * 10000), (int)Math.Round(yr2 * 10000));



                MbeObjPinSMD pad = new MbeObjPinSMD();
                pad.Shape = MbeObjPin.PadShape.Obround;
                pad.Width = padWidth;
                pad.Height = padWidth;
                pad.Layer = MbeLayer.LayerValue.CMP;
                pad.PinNum = pinNumber.ToString();
                pad.SetPos(ptc, 0);
                objList.AddLast(pad);

                pinNumber++;

                if (padLRwidth > padLRheight) {
                    MbeObjLine line = new MbeObjLine();
                    line.SetPos(pt1, 0);
                    line.SetPos(ptc, 1);
                    line.LineWidth = padWidth;
                    line.Layer = MbeLayer.LayerValue.CMP;
                    objList.AddLast(line);

                    line = new MbeObjLine();
                    line.SetPos(pt2, 0);
                    line.SetPos(ptc, 1);
                    line.LineWidth = padWidth;
                    line.Layer = MbeLayer.LayerValue.CMP;
                    objList.AddLast(line);

                    line = new MbeObjLine();
                    line.SetPos(pt1, 0);
                    line.SetPos(pt2, 1);
                    line.LineWidth = padWidth;
                    line.Layer = MbeLayer.LayerValue.MMC;
                    objList.AddLast(line);

                    line = new MbeObjLine();
                    line.SetPos(pt1, 0);
                    line.SetPos(pt2, 1);
                    line.LineWidth = padWidth + 2000;
                    line.Layer = MbeLayer.LayerValue.STC;
                    objList.AddLast(line);
                }

                y += param.pinPitch;
            }

            y = (param.y1 + param.y2) / 4;
            x = param.pinPitch * (param.xPinCount - 1) / 2;
            y1 = y - (padTBheight - param.padWidth) / 2;
            y2 = y + (padTBheight - param.padWidth) / 2;


            for (int i = 0; i < param.xPinCount; i++) {
                rotateXY(x, y, param.angle, out xr, out yr);
                rotateXY(x, y1, param.angle, out xr1, out yr1);
                rotateXY(x, y2, param.angle, out xr2, out yr2);

                ptc = new Point((int)Math.Round(xr * 10000), (int)Math.Round(yr * 10000));
                pt1 = new Point((int)Math.Round(xr1 * 10000), (int)Math.Round(yr1 * 10000));
                pt2 = new Point((int)Math.Round(xr2 * 10000), (int)Math.Round(yr2 * 10000));


                MbeObjPinSMD pad = new MbeObjPinSMD();
                pad.Shape = MbeObjPin.PadShape.Obround;
                pad.Width = padWidth;
                pad.Height = padWidth;
                pad.Layer = MbeLayer.LayerValue.CMP;
                pad.PinNum = pinNumber.ToString();

                pad.SetPos(ptc, 0);
                objList.AddLast(pad);

                pinNumber++;

                if (padTBheight > padTBwidth) {
                    MbeObjLine line = new MbeObjLine();
                    line.SetPos(pt1, 0);
                    line.SetPos(ptc, 1);
                    line.LineWidth = padWidth;
                    line.Layer = MbeLayer.LayerValue.CMP;
                    objList.AddLast(line);

                    line = new MbeObjLine();
                    line.SetPos(pt2, 0);
                    line.SetPos(ptc, 1);
                    line.LineWidth = padWidth;
                    line.Layer = MbeLayer.LayerValue.CMP;
                    objList.AddLast(line);

                    line = new MbeObjLine();
                    line.SetPos(pt1, 0);
                    line.SetPos(pt2, 1);
                    line.LineWidth = padWidth;
                    line.Layer = MbeLayer.LayerValue.MMC;
                    objList.AddLast(line);

                    line = new MbeObjLine();
                    line.SetPos(pt1, 0);
                    line.SetPos(pt2, 1);
                    line.LineWidth = padWidth + 2000;
                    line.Layer = MbeLayer.LayerValue.STC;
                    objList.AddLast(line);
                }

                x -= param.pinPitch;
            }

            {
                MbeObjPinSMD pad = new MbeObjPinSMD();
                pad.Shape = MbeObjPin.PadShape.Obround;
                pad.Width = 3000;
                pad.Height = 3000;
                pad.Layer = MbeLayer.LayerValue.PLC;
                pad.SetPos(new Point(0, 0), 0);
                objList.AddLast(pad);
            }



            Point ptOrigin = new Point(0, 0);
            MbeDocInfo docinfo = new MbeDocInfo();
            //docinfo.SizeWorkArea = tempRc.SizeRect();

            StringBuilder strBuilder = new StringBuilder();
            StringWriter stringWriter = null;
            try {
                stringWriter = new StringWriter(strBuilder);
                WriteCE3 writeMb3 = new WriteCE3(stringWriter);
                WriteMb3(writeMb3, objList, ptOrigin, docinfo);
                stringWriter.Flush();
                string strBuff = strBuilder.ToString();
                //Clipboard.SetDataObject(strBuff);
                Clipboard.SetData(MainForm.mbeClipboardFormat.Name, strBuff);
            }
            catch (Exception) {
                return;
            }
            return;
        }

        
        
        
        private static void WriteMb3(WriteCE3 writeMb3, LinkedList<MbeObj> mbeObjList, Point origin, MbeDocInfo docinfo)
        {
            Point offset = new Point(-origin.X, -origin.Y);
            writeMb3.WriteRecord("+MBE_DATA_V.1.0");
            writeMb3.WriteNewLine();
            docinfo.WrMb3(writeMb3);
            foreach (MbeObj obj in mbeObjList) {
                if (obj.DeleteCount < 0) {
                    obj.WrMb3(writeMb3, origin);
                }
            }
            writeMb3.WriteRecord("-MBE_DATA_V.1.0");
            writeMb3.WriteNewLine();
        }

    }

 
    
    
    
    class SmdICpadParam
    {
        public enum packageType
        {
            QFP,
            PLCC
        }

        public SmdICpadParam()
        {
            xPinCount = SmdICpadCore.DEFAULT_X_PINCOUNT;
            yPinCount = SmdICpadCore.DEFAULT_Y_PINCOUNT;
            pkgtype = packageType.QFP;
            x1      = SmdICpadCore.DEFAULT_X1;
            x2      = SmdICpadCore.DEFAULT_X2;
            y1      = SmdICpadCore.DEFAULT_Y1;
            y2      = SmdICpadCore.DEFAULT_Y2;
            pinPitch = SmdICpadCore.DEFAULT_PIN_PITCH;
            padWidth = SmdICpadCore.DEFAULT_PAD_WIDTH;
            angle = 0;
        }


        public int xPinCount;
        public int yPinCount;
        public packageType pkgtype;
        public double x1;
        public double x2;
        public double y1;
        public double y2;
        public double pinPitch;
        public double padWidth;
        public double angle;
    }

}
